/*
	ga_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		GA_SEARCH_MODULE

	MODIFICATIONS:
	Tue Dec 26 21:08:06 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "ga_search.hh"	// definition of GA_SEARCH_MODULE

// flag signifying main loop is to terminate
int ga_module_done = 0;

//signal handler for ^C
extern "C" void ga_module_quit(int sig);
void ga_module_quit(int sig)
{
	ga_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int ga_module_run();

int ga_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	GA_SEARCH_MODULE *ga_search = new GA_SEARCH_MODULE();

	// set the SIGINT handler
	signal(SIGINT, ga_module_quit);

	// enter main loop
	while(!ga_module_done)
	{
		ga_search->controller();

		timer->wait();
	}

	// Delete Modules
	delete ga_search;

	// Delete Timer
	delete timer;
}

